/*
 * Copyright (C) oStorybook Team
 *
 * This program is free software, see <http://www.gnu.org/licenses/>.
 *
 * Parts of this code are from the NovaWorx project. Other parts are
 * from the SHEF project developed and published by Bob Tantlinger.
 */
package shef.editors.wys;

import shef.actions.manager.ActionList;

/**
 * some codes are inspired by SHEF from Sourceforge by Bob Tantlinger initial adaptation by favdb (2020)
 *
 */
public class HTMLEditorActionFactory {

	public static ActionList createFontSizeActionList(WysiwygEditor editor) {
		ActionList list = new ActionList("font-size");
		int[] t = HTMLFontSizeAction.FONT_SIZES;
		for (int i = 0; i < t.length; i++) {
			list.add(new HTMLFontSizeAction(editor, i));
		}

		return list;
	}

	public static ActionList createBlockElementActionList(WysiwygEditor editor) {
		ActionList list = new ActionList("paragraph");
		//list.add(new HTMLBlockAction(HTMLBlockAction.DIV));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.P));
		list.add(null);
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.BLOCKQUOTE));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.PRE));
		list.add(null);
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H1));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H2));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H3));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H4));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H5));
		list.add(new HTMLBlockAction(editor, HTMLBlockAction.H6));
		return list;
	}

}
