/*
 Storybook: Open Source software for novelists and authors.
 Copyright (C) 2008 - 2012 Martin Mustun

 This program is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
 /* vérification OK */
package storybook.action;

import net.infonode.docking.View;
import storybook.App;
import storybook.toolkit.swing.SwingUtil;
import storybook.ui.MainFrame;
import storybook.ui.SbView;
import storybook.ui.SbView.VIEWNAME;
import storybook.ui.dialog.RenameDlg;

/**
 * @author martin
 *
 */
public class ActionHandler {

	private final MainFrame mainFrame;

	public ActionHandler(MainFrame mainframe) {
		mainFrame = mainframe;
	}

	public void handleRenameCity() {
		RenameDlg dlg = new RenameDlg(mainFrame, "city");
		SwingUtil.showModalDialog(dlg, mainFrame);
	}

	public void handleRenameCountry() {
		RenameDlg dlg = new RenameDlg(mainFrame, "country");
		SwingUtil.showModalDialog(dlg, mainFrame);
	}

	public void handleRenameTagCategory() {
		RenameDlg dlg = new RenameDlg(mainFrame, "tag");
		SwingUtil.showModalDialog(dlg, mainFrame);
	}

	public void handleRenameItemCategory() {
		RenameDlg dlg = new RenameDlg(mainFrame, "item");
		SwingUtil.showModalDialog(dlg, mainFrame);
	}

	public void handleShowChronoView() {
		showAndFocus(VIEWNAME.CHRONO);
	}

	public void handleShowTimelineView() {
		showAndFocus(VIEWNAME.TIMELINE);
	}

	public void handleShowStoryboardView() {
		showAndFocus(VIEWNAME.STORYBOARD);
	}

	public void handleShowStorymapView() {
		showAndFocus(VIEWNAME.STORYMAP);
	}

	public void handleShowAttributesView() {
		showAndFocus(VIEWNAME.ATTRIBUTES);
	}

	public void handleShowAttributesListView() {
		showAndFocus(VIEWNAME.ATTRIBUTESLIST);
	}

	public void handleShowBookView() {
		showAndFocus(VIEWNAME.BOOK);
	}

	public void handleShowManageView() {
		showAndFocus(VIEWNAME.MANAGE);
	}

	public void handleShowReadingView() {
		showAndFocus(VIEWNAME.READING);
	}

	public void handleShowMemoria() {
		showAndFocus(VIEWNAME.MEMORIA);
	}

	public void handleShowStoryboard() {
		showAndFocus(VIEWNAME.STORYBOARD);
	}

	public void handleShowStorymap() {
		showAndFocus(VIEWNAME.STORYMAP);
	}

	public void handleShowTree() {
		showAndFocus(VIEWNAME.TREE);
	}

	public void handleShowInfo() {
		showAndFocus(VIEWNAME.INFO);
	}

	public void handleShowMemo() {
		showAndFocus(VIEWNAME.MEMOS);
	}

	public void handleShowNavigation() {
		showAndFocus(VIEWNAME.NAVIGATION);
	}

	public void handleDumpAttachedViews() {
		//mainFrame.getBookController().printAttachedViews();
	}

	public void handleDummy() {
		//App.trace(this.getClass().getSimpleName()+"handleDummy()");
	}

	public void handleShowCategories() {
		showAndFocus(VIEWNAME.CATEGORIES);
	}

	public void handleShowChapters() {
		showAndFocus(VIEWNAME.CHAPTERS);
	}

	public void handleShowGenders() {
		showAndFocus(VIEWNAME.GENDERS);
	}

	public void handleShowIdeas() {
		showAndFocus(VIEWNAME.IDEAS);
	}

	public void handleShowInternals() {
		showAndFocus(VIEWNAME.INTERNALS);
	}

	public void handleShowItems() {
		showAndFocus(VIEWNAME.ITEMS);
	}

	public void handleShowItemlinks() {
		showAndFocus(VIEWNAME.ITEMLINKS);
	}

	public void handleShowLocations() {
		showAndFocus(VIEWNAME.LOCATIONS);
	}

	public void handleShowParts() {
		showAndFocus(VIEWNAME.PARTS);
	}

	public void handleShowPersons() {
		showAndFocus(VIEWNAME.PERSONS);
	}

	public void handleShowPlots() {
		showAndFocus(VIEWNAME.PLOTS);
	}

	public void handleShowScenes() {
		showAndFocus(VIEWNAME.SCENES);
	}

	public void handleShowStrands() {
		showAndFocus(VIEWNAME.STRANDS);
	}

	public void handleShowTags() {
		showAndFocus(VIEWNAME.TAGS);
	}

	public void handleShowTaglinks() {
		showAndFocus(VIEWNAME.TAGLINKS);
	}

	private void showAndFocus(SbView.VIEWNAME viewName) {
		View view = mainFrame.getView(viewName);
		view.restore();
		view.restoreFocus();
	}

	public void handleRecentClear() {
		App.getInstance().clearRecentFiles();
	}

	public void handleClose() {
		mainFrame.close(true);
	}

}
